// Code generated by mockery v2.12.1. DO NOT EDIT.

package mocks

import (
	dao "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dao"
	dto "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dto"

	mock "github.com/stretchr/testify/mock"

	testing "testing"
)

// CollectionService is an autogenerated mock type for the CollectionService type
type CollectionService struct {
	mock.Mock
}

// GetAllCollection provides a mock function with given fields:
func (_m *CollectionService) GetAllCollection() ([]dao.Collection, error) {
	ret := _m.Called()

	var r0 []dao.Collection
	if rf, ok := ret.Get(0).(func() []dao.Collection); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Collection)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCollectionByUserId provides a mock function with given fields: id
func (_m *CollectionService) GetCollectionByUserId(id uint) (dto.MyCollectionDTO, error) {
	ret := _m.Called(id)

	var r0 dto.MyCollectionDTO
	if rf, ok := ret.Get(0).(func(uint) dto.MyCollectionDTO); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Get(0).(dto.MyCollectionDTO)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProgress provides a mock function with given fields: userID, bookID
func (_m *CollectionService) GetProgress(userID uint, bookID uint) (int, error) {
	ret := _m.Called(userID, bookID)

	var r0 int
	if rf, ok := ret.Get(0).(func(uint, uint) int); ok {
		r0 = rf(userID, bookID)
	} else {
		r0 = ret.Get(0).(int)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint, uint) error); ok {
		r1 = rf(userID, bookID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// TrackProgress provides a mock function with given fields: userID, bookID, progress
func (_m *CollectionService) TrackProgress(userID uint, bookID uint, progress int) (dto.ProgressDTO, error) {
	ret := _m.Called(userID, bookID, progress)

	var r0 dto.ProgressDTO
	if rf, ok := ret.Get(0).(func(uint, uint, int) dto.ProgressDTO); ok {
		r0 = rf(userID, bookID, progress)
	} else {
		r0 = ret.Get(0).(dto.ProgressDTO)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint, uint, int) error); ok {
		r1 = rf(userID, bookID, progress)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewCollectionService creates a new instance of CollectionService. It also registers the testing.TB interface on the mock and a cleanup function to assert the mocks expectations.
func NewCollectionService(t testing.TB) *CollectionService {
	mock := &CollectionService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
